-- Global variables
FSRT = {};
FSRT.version = "1.3.1";
FSRT.timeSinceUpdate = 0;
FSRT.updateFreq = 0.1;
FSRT.lineCount = 0;
FSRT.timeTillRegen = 0;
FSRT.duration = 0;
FSRT.fsr = 0;
FSRT.oldMana = 0;
FSRT.plusMana = 0;
FSRT.minusMana = 0;


-- Print to chat frame
function FSRT:Print(msg)

	if ( not msg ) then
		msg = "nil";
	end

	DEFAULT_CHAT_FRAME:AddMessage("FSRT: "..msg);

end

-- Slash command
function FSRT.Command(cmnd)

	local _, _, cmd, arg = string.find(strlower(cmnd), "(.+) (.+)");
	cmd = cmd or cmnd;
	
	if ( cmd == "show" ) or ( cmd == "on" ) then

		FSRTFrame:Show();
		FSRTConfig.visible = 1;

	elseif ( cmd == "hide" ) or ( cmd == "off" ) then

		FSRTFrame:Hide();
		FSRTConfig.visible = nil;

	elseif ( cmd == "icr" ) then

		if arg then
			FSRTConfig.icr = tonumber(arg);
			FSRT:Print("Set in-casting regen to "..FSRTConfig.icr);
		else
			FSRT:Print("In-casting regen: "..(FSRTConfig.icr or "nil"));
		end

	elseif ( cmd == "mps" ) then

		if arg then
			FSRTConfig.mps = tonumber(arg);
			FSRT:Print("Set mana/spirit to "..FSRTConfig.mps);
		else
			FSRT:Print("Mana/spirit: "..(FSRTConfig.mps or "nil"));
		end

	elseif ( cmd == "mpi" ) then

		if arg then
			FSRTConfig.mpi = tonumber(arg);
			FSRT:Print("Set mana/int to "..FSRTConfig.mpi);
		else
			FSRT:Print("Mana/int: "..(FSRTConfig.mpi or "nil"));
		end

	elseif ( cmd == "reset" ) then
	
		FSRT:Reset();

	elseif ( cmd == "scale" ) then
	
		FSRTConfig.scale = tonumber(arg);
		FSRTFrame:SetScale(FSRTConfig.scale);
		
	elseif ( cmd == "backdrop" ) then
	
		if FSRTConfig.noBackdrop then
			FSRTFrame:SetBackdropColor(0,0,0,0.5);
			FSRTFrame:SetBackdropBorderColor(1,1,1,1);
			FSRTConfig.noBackdrop = nil;
		else
			FSRTFrame:SetBackdropColor(0,0,0,0);
			FSRTFrame:SetBackdropBorderColor(0,0,0,0);
			FSRTConfig.noBackdrop = 1;
		end

	elseif ( cmd == "center" ) then
	
		FSRTFrame:ClearAllPoints();
		FSRTFrame:SetPoint("CENTER", "UIParent", "CENTER");

	elseif ( cmd == "duration" ) then

		if arg == "on" or arg == "add" then
			FSRT:AddLine("Duration", "0:00.0");
		elseif arg == "off" or arg == "rem" or arg == "delete" or arg == "del" then
			FSRT:RemoveLine("Duration");
		end

	elseif ( cmd == "fsr" ) then

		if arg == "on" or arg == "add" then
			FSRT:AddLine("FSR", "0.0%");
		elseif arg == "off" or arg == "rem" or arg == "delete" or arg == "del" then
			FSRT:RemoveLine("FSR");
		end

	elseif ( cmd == "mptick" ) then

		if arg == "on" or arg == "add" then
			FSRT:AddLine("mp/tick", "0");
		elseif arg == "off" or arg == "rem" or arg == "delete" or arg == "del" then
			FSRT:RemoveLine("mp/tick");
		end

	elseif ( cmd == "spirit" ) then

		if arg == "on" or arg == "add" then
			FSRT:AddLine("Spi:mp5", "0.00");
		elseif arg == "off" or arg == "rem" or arg == "delete" or arg == "del" then
			FSRT:RemoveLine("Spi:mp5");
		end

	elseif ( cmd == "int" ) then

		if arg == "on" or arg == "add" then
			FSRT:AddLine("Int:mp5", "0.00");
		elseif arg == "off" or arg == "rem" or arg == "delete" or arg == "del" then
			FSRT:RemoveLine("Int:mp5");
		end

	elseif ( cmd == "+mana" ) then

		if arg == "on" or arg == "add" then
			FSRT:AddLine("+Mana", "0");
		elseif arg == "off" or arg == "rem" or arg == "delete" or arg == "del" then
			FSRT:RemoveLine("+Mana");
		end

	elseif ( cmd == "-mana" ) then

		if arg == "on" or arg == "add" then
			FSRT:AddLine("-Mana", "0");
		elseif arg == "off" or arg == "rem" or arg == "delete" or arg == "del" then
			FSRT:RemoveLine("-Mana");
		end

	elseif ( cmd == "help" ) then

		FSRT:Print("FSRT version "..FSRT.version.." - Commands");
		FSRT:Print("show/on - enable the mod");
		FSRT:Print("hide/off - disable the mod");
		FSRT:Print("mps - enter your mana-per-spirit (currently "..FSRTConfig.mps..")");
		FSRT:Print("mpi - enter your mana-per-int (currently "..FSRTConfig.mpi..")");
		FSRT:Print("icr - enter your in-casting-regen (currently "..FSRTConfig.icr..")");
		FSRT:Print("reset - resets the statistics");
		FSRT:Print("scale - Adjust the scale of the window");
		FSRT:Print("backdrop - hide/show the frame background");
		FSRT:Print("center - Centers the window in the screen");
		FSRT:Print("duration (on/off) - duration of the fight");
		FSRT:Print("fsr (on/off) - % time spent in five second rule");
		FSRT:Print("mptick (on/off) - Mana per tick");
		FSRT:Print("spirit (on/off) - Spirit to mp5 comparison");
		FSRT:Print("int (on/off) - Int to mp/5 comparison");
		FSRT:Print("+mana (on/off) - Total mana gained");
		FSRT:Print("-mana (on/off) - Total mana lost");
		FSRT:Print("help - display this help message");

	else

		FSRT:Print("Command \'"..cmd.."\' not understood. For help type /fsrt help");

	end

end

function FSRT:Reset()

	FSRT.timeTillRegen = 0;
	FSRT.duration = 0;
	FSRT.fsr = 0;
	FSRT.plusMana = 0;
	FSRT.minusMana = 0;

	FSRTFrameStatusBar:SetValue(0);
	FSRT:SetText("Duration", "0:00.0");
	FSRT:SetText("FSR", "0.0%");
	FSRT:SetText("mp/tick", "0");
	FSRT:SetText("Spi:mp5", "0.00");
	FSRT:SetText("Int:mp5", "0.00");
	FSRT:SetText("+Mana", "0");
	FSRT:SetText("-Mana", "0");

end

function FSRT:SetText(label, text)

	local line = FSRTConfig.lines[label];

	if line then
		getglobal("FSRTFrameLabel"..line):SetText(label or "nil");
		getglobal("FSRTFrameValue"..line):SetText(text or "nil");
	end

end

function FSRT:AddLine(label, text)

	if FSRT.lineCount < 8 and not FSRTConfig.lines[label] then
		FSRT.lineCount = FSRT.lineCount + 1;
		FSRTConfig.lines[label] = FSRT.lineCount;
		FSRT:SetText(label, text);
	end

	FSRT:Settle();

end

function FSRT:RemoveLine(label)

	FSRTConfig.lines[label] = nil;

	FSRT:Settle();

end

function FSRT:Settle()

	FSRT.lineCount = 0;
	local lines = { };

	for var, line in FSRTConfig.lines do
		lines[line] = var;
	end

	for i = 1, 8 do
		getglobal("FSRTFrameLabel"..i):SetText(" ");
		getglobal("FSRTFrameValue"..i):SetText(" ");
		if lines[i] then
			FSRT.lineCount = FSRT.lineCount + 1;
			FSRTConfig.lines[lines[i]] = FSRT.lineCount;
			FSRT:SetText(lines[i], " ");
		end
	end

	local height = 10*FSRT.lineCount + 12;

	if height < 20 then
		FSRTFrame:SetHeight(20);
	else
		FSRTFrame:SetHeight(height);
	end
	
	lines = nil;

end

-- On load
function FSRT:OnLoad(class)

	-- Register slash commands
	SlashCmdList["FSRT"] = FSRT.Command
	SLASH_FSRT1 = "/fsrt";

	class:RegisterEvent("VARIABLES_LOADED");
	class:RegisterEvent("PLAYER_ENTERING_WORLD");
	class:RegisterEvent("UNIT_MANA");
	class:RegisterEvent("PLAYER_REGEN_ENABLED");
	class:RegisterEvent("PLAYER_REGEN_DISABLED");

	FSRTFrame:SetBackdropColor(0, 0, 0, 0.5);
	FSRTFrameStatusBar:SetMinMaxValues(0, 5);

end

-- On Update
function FSRT:OnUpdate(elapsed)

	self.timeSinceUpdate = self.timeSinceUpdate + elapsed;

	if self.timeTillRegen > 0 then
		self.timeTillRegen = self.timeTillRegen - elapsed;
	end

	if (UnitMana("player") < UnitManaMax("player")) and self.recording then
		self.duration = self.duration + elapsed;

		if self.timeTillRegen > 0 then
			self.fsr = self.fsr + elapsed;
		end
	end

	if self.timeSinceUpdate >= self.updateFreq then
		self.timeSinceUpdate = 0;
		local fsrp = self.fsr / (self.duration + 0.001);
		local str = string.format("%0.2f", 2/(5*FSRTConfig.mps*(1 - fsrp + FSRTConfig.icr*fsrp)));
		if strlen(str) > 5 then str = "--"; end

		FSRTFrameStatusBar:SetValue(self.timeTillRegen);
		FSRT:SetText("Duration", string.format("%d:%04.1f", floor(self.duration/60), floor(mod(self.duration*10, 600))/10));
		FSRT:SetText("FSR", string.format("%0.1f%%", fsrp*100));
		FSRT:SetText("Spi:mp5", str);
		FSRT:SetText("Int:mp5", string.format("%0.2f", self.duration/(5*FSRTConfig.mpi)));
		FSRT:SetText("+Mana", self.plusMana);
		FSRT:SetText("-Mana", self.minusMana);
	end

end

--Spirit to mp/5 comparison
--(1 - self.fsr/self.duration)(self.mps*spirit) + (self.fsr/self.duration)(self.mps*spirit*self.icr) = (self.duration / 5)
--(duration/2)(spirit)(mps)(1 - fsrp + fsrp*icr) = (duration / 5)
--spirit = 2 / (5 * mps * (1 - fsrp + fsrp*icr))

--Int to mp/5 comparison
--mana = duration / 5
--int * mpi = duration / 5
--int = duration / (5 * mpi)

-- Event handler
function FSRT:OnEvent(event)

	if ( FSRT.eventHandler[event] ) then
		FSRT.eventHandler[event](arg1);
	end

end

FSRT.eventHandler = { };

FSRT.eventHandler["VARIABLES_LOADED"] = function ()

	if not FSRTConfig then FSRTConfig = {}; end
	if not FSRTConfig.mps then FSRTConfig.mps = 0.25; end
	if not FSRTConfig.mpi then FSRTConfig.mpi = 15; end
	if not FSRTConfig.icr then FSRTConfig.icr = 0; end
	if not FSRTConfig.scale then FSRTConfig.scale = 1; end
	if not FSRTConfig.lines then FSRTConfig.lines = { }; end

	FSRT:Settle();
	FSRT:Reset();

	FSRTFrame:SetScale(FSRTConfig.scale);

	if FSRTConfig.noBackdrop then
		FSRTFrame:SetBackdropColor(0,0,0,0);
		FSRTFrame:SetBackdropBorderColor(0,0,0,0);
	end

	if FSRTConfig.visible then
		FSRTFrame:Show();
	end

end

FSRT.eventHandler["PLAYER_ENTERING_WORLD"] = function ()

	local _, class = UnitClass("player");

	if ( class == "PRIEST" ) or ( class == "MAGE" ) then
		FSRTConfig.mps = 0.25;
	else
		FSRTConfig.mps = 0.2;
	end
	
end

FSRT.eventHandler["PLAYER_REGEN_DISABLED"] = function ()

	FSRT.recording = 1;
	FSRT:Reset();

end

FSRT.eventHandler["PLAYER_REGEN_ENABLED"] = function ()

	FSRT.recording = nil;

end

-- Check for health updates
FSRT.eventHandler["UNIT_MANA"] = function (unit)

	if ( unit == "player" ) and ( UnitPowerType("player") == 0 ) then

		local newMana = UnitMana("player");

		if newMana - FSRT.oldMana > 0 then
			FSRT:SetText("mp/tick", newMana-FSRT.oldMana);

			if FSRT.recording then
				FSRT.plusMana = FSRT.plusMana + newMana - FSRT.oldMana;
			end

		else
			FSRT.timeTillRegen = 5;
			FSRT:SetText("mp/tick", "0");

			if FSRT.recording then
				FSRT.minusMana = FSRT.minusMana + newMana - FSRT.oldMana;
			end
		end

		FSRT.oldMana = newMana;

	end

end
