local diTTDefaults = {
	Location = "DEFAULT",
	ColorGuild = { r=255, g=210, b=0 },
	ColorTarget = { r=255, g=210, b=0 },
}

-- Set color for 1 - Guild, 2 - Target
local diCWSetColor
local diTmpColorGuild
local diTmpColorTarget

local function diPrintHelp ()
	strhelp = 'DITOOLTIP_HELP'
	local i = 1;
	local text = TEXT(getglobal(strhelp..i));
	while text do
		DEFAULT_CHAT_FRAME:AddMessage(text);
		i = i + 1;
		text = TEXT(getglobal(strhelp..i));
	end
end

local function FormColor ( color )
	local fColor = "|cffffd200"
	local gColor1 = ""
	local gColor2 = ""
	local gColor3 = ""
	if (color) then
		gColor1 = string.format("%x", floor(color.r))
		if (string.len(gColor1)<2) then
			gColor1 = "0" .. gColor1
		end
		gColor2 = string.format("%x", floor(color.g))
		if (string.len(gColor2)<2) then
			gColor2 = "0" .. gColor2
		end
		gColor3 = string.format("%x", floor(color.b))
		if (string.len(gColor3)<2) then
			gColor3 = "0" .. gColor3
		end
		fColor = "|cff" .. gColor1 .. gColor2 .. gColor3
	end
	return TEXT(fColor)
end

function GameTooltip_SetDefaultAnchor(tooltip, parent)
	if (diToolTipDB == nil) then
		tooltip:SetOwner(parent, "ANCHOR_NONE")
		tooltip:SetPoint("BOTTOMRIGHT", "UIParent", "BOTTOMRIGHT", -CONTAINER_OFFSET_X - 13, CONTAINER_OFFSET_Y)
		return
	elseif (diToolTipDB.Location == "CURSOR") then
		tooltip:SetOwner(parent, "ANCHOR_CURSOR")
		tooltip:ClearAllPoints()
		return
	end
	tooltip:SetOwner(parent, "ANCHOR_NONE")
	if (diToolTipDB.Location == "TOP") then
		tooltip:SetPoint("TOP", "UIParent", "TOP", 0, -13)
	elseif (diToolTipDB.Location == "RIGHT") then
		tooltip:SetPoint("LEFT", "UIParent", "RIGHT", 13, 0)
	elseif (diToolTipDB.Location == "LEFT") then
		tooltip:SetPoint("RIGHT", "UIParent", "LEFT", 13, 0)
	elseif (diToolTipDB.Location == "BOTTOM") then
		tooltip:SetPoint("BOTTOM", "UIParent", "BOTTOM", 0, 23)
	elseif (diToolTipDB.Location == "TOPRIGHT") then
		tooltip:SetPoint("TOPRIGHT", "UIParent", "TOPRIGHT", -13, -13)
	elseif (diToolTipDB.Location == "TOPLEFT") then
		tooltip:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 13, -13)
	elseif (diToolTipDB.Location == "BOTTOMRIGHT") then
		tooltip:SetPoint("BOTTOMRIGHT", "UIParent", "BOTTOMRIGHT", 13, 23)
	elseif (diToolTipDB.Location == "BOTTOMLEFT") then
		tooltip:SetPoint("BOTTOMLEFT", "UIParent", "BOTTOMLEFT", 13, 23)
	else
		tooltip:SetPoint("BOTTOMRIGHT", "UIParent", "BOTTOMRIGHT", -CONTAINER_OFFSET_X - 13, CONTAINER_OFFSET_Y)
	end
end

function diToolTip_ColorPickerOK()
	local r,g,b = ColorPickerFrame:GetColorRGB()
	if ( diCWSetColor == 1 ) then
		diToolTipDB.ColorGuild = {}
		diToolTipDB.ColorGuild.r = floor(r*255)
		diToolTipDB.ColorGuild.g = floor(g*255)
		diToolTipDB.ColorGuild.b = floor(b*255)
	else
		diToolTipDB.ColorTarget = {}
		diToolTipDB.ColorTarget.r = floor(r*255)
		diToolTipDB.ColorTarget.g = floor(g*255)
		diToolTipDB.ColorTarget.b = floor(b*255)
	end
end

function diToolTip_ColorPickerCancel () 
	diToolTipDB.ColorGuild = diTmpColorGuild
	diToolTipDB.ColorTarget = diTmpColorTarget
end

function diToolTip_ColorPickerShow ( color )
	local cpsColor = {}
	if ( color ) then
		cpsColor.r = color.r
		cpsColor.g = color.g
		cpsColor.b = color.b
	else
		cpsColor.r = diTTDefaults.ColorGuild.r
		cpsColor.g = diTTDefaults.ColorGuild.g
		cpsColor.b = diTTDefaults.ColorGuild.b
	end
	diTmpColorGuild = diToolTipDB.ColorGuild
	diTmpColorTarget = diToolTipDB.ColorTarget
	ColorPickerFrame.func = diToolTip_ColorPickerOK 
	ColorPickerFrame.cancelFunc = diToolTip_ColorPickerCancel
	ColorPickerFrame:SetColorRGB(cpsColor.r, cpsColor.g , cpsColor.b)
	ColorPickerFrame:Show()
end

function diToolTip_Show()
	if (UnitExists("mouseover")) then
		local guildName, guildRankName, guildRankIndex = GetGuildInfo("mouseover")
		if (guildName) then
			local gColor
			if ( diToolTipDB.ColorGuild ) then
				gColor = FormColor ( diToolTipDB.ColorGuild )
			else
				gColor = FormColor ()
			end
			GameTooltip:AddLine(gColor .. "<" .. guildName .. ">")
		end
		unit = "mouseover"
		pid = unit .. "target"
		if (UnitExists(pid) and (pid~=unit)) then
			local tColor
			if ( diToolTipDB.ColorTarget ) then
				tColor = FormColor ( diToolTipDB.ColorTarget )
			else
				tColor = FormColor ()
			end
			GameTooltip:AddLine( tColor .. DITOOLTIP_TARGET .. (UnitName(pid) or DITOOLTIP_UNKNOW))
		end
		GameTooltip:Show()
	end
end

function diToolTip_OnEvent()
	if (event == "UPDATE_MOUSEOVER_UNIT") then
		diToolTip_Show()
	elseif (event == "VARIABLES_LOADED") then
		if (diToolTipDB == nil) then
			diToolTipDB = {}
			diToolTipDB = diTTDefaults
		end
		DEFAULT_CHAT_FRAME:AddMessage(DITOOLTIP_LOADED);
	end
end

function diToolTip_SlashHandler(msg)
	if ( msg ) then
		local command = string.upper(msg)
		if ( command == "" ) or (command == "HELP") then
			diPrintHelp ()
		elseif ( command == "COLORG" ) then
			diCWSetColor = 1
			diToolTip_ColorPickerShow ( diToolTipDB.ColorGuild )
		elseif ( command == "COLORT" ) then
			diCWSetColor = 2
			diToolTip_ColorPickerShow ( diToolTipDB.ColorTarget )
		elseif ( command == "RESET" ) then
			diToolTipDB = {}
			diToolTipDB = diTTDefaults
			DEFAULT_CHAT_FRAME:AddMessage(DITOOLTIP_RESETED)			
		else
			diToolTipDB.Location = command
		end
	else
		diPrintHelp ()
	end
end

function diToolTip_Enable()
	SlashCmdList["DITOOLTIP"] = diToolTip_SlashHandler
	SLASH_DITOOLTIP1 = "/ditooltip"
	SLASH_DITOOLTIP2 = "/ditt"
	
	GameTooltip.existingSetUnit = GameTooltip.SetUnit
	function GameTooltip:SetUnit(unit)
		local result, reason = pcall(GameTooltip.existingSetUnit, GameTooltip, unit)
		if(not result) then
			error(reason, 2)
		end
		diToolTip_Show()
	end
	
	local diTTFrame = CreateFrame("Frame",nil,UIParent)

	diTTFrame:SetScript("OnEvent", diToolTip_OnEvent)
	diTTFrame:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
	diTTFrame:RegisterEvent("VARIABLES_LOADED")
end

diToolTip_Enable()
